import javax.swing.*;
import java.awt.*;
import DMObject;
import DMModel;
import DMControl;

public class DMView extends JPanel
{
    DMModel M;
    DMControl C;
    double scale;

    public DMView( DMModel inM )
    {
	M = inM;
	C = new DMControl( this, inM );
	addMouseListener( C );
	addMouseMotionListener( C );
       	addKeyListener( C );
	scale = 1.0;
	setBackground(Color.white);
	setForeground(Color.black);
    }
    
    public void paint( Graphics g )
    {
	super.paint(g);
	Dimension r;
	int i;

	g.setFont(new Font("Helvetica",Font.PLAIN,9));
	//	System.out.println("Starting paint...");
	r = getBounds().getSize();
	
	for(i=0;i<M.getSize();i++)
	    M.getObjectAt(i).drawSelf(g,r);
	//	System.out.println("Ending paint...");
	
	C . drawControls( g );
    }

    public void changeScale( double inNewScale )
    {
	Dimension r = getBounds().getSize();

	setSize( (int) (r.getWidth()*inNewScale/scale), (int) (r.getHeight()*inNewScale/scale) );
	scale = inNewScale;
	validate();
    }
}






