import TclSnippet;
import java.lang.*;
import java.util.*;
import java.io.*;

class NSObject extends Object
{
    TclSnippet snippet;
    String name;
    ArrayList attributes;
    int arrayIndex;

    public NSObject( TclSnippet inSnippet, String inName )
    {
	snippet = inSnippet;
	
	// Initialize the objects data structure
	attributes = new ArrayList();
	arrayIndex = -1;
	setName( inName );
    }
    
    public TclSnippet getSnippet()
    {
	return snippet;
    }

    public void setName( String inName )
    {
	name = inName;
    }
    
    public String getName()
    {
	return name;
    }
    
    public int getArrayIndex()
    {
	return arrayIndex;
    }

    public void setArrayIndex( int newArrayIndex )
    {
	arrayIndex = newArrayIndex;
    }

    public int getAttributeCount()
    {
	return attributes.size();
    }

    public void arrayIndexGone( int aig )
    {
	if (arrayIndex>aig) {
	    arrayIndex--;
	} else if (arrayIndex==aig) {
	    arrayIndex=-1;
	}
    }

    public void setAttribute( int inAttrIndex, String inNewValue )
    {
	if (inAttrIndex >= attributes.size())
	    attributes.add( inAttrIndex, inNewValue );
	else
	    attributes.set( inAttrIndex, inNewValue );
    }
    
    public String getAttribute( int inAttrIndex )
    {
	if (inAttrIndex >= attributes.size())
	    return "";
	else
	    return ((String) attributes.get( inAttrIndex ));
    }

    public String toString()
    {
	String str;
	int i;
	
	str = snippet.getName() + "\n";
	str = str + name + "\n";
	str = str + Integer.toString(arrayIndex) + "\n";

	for (i=0; i<attributes.size(); i++) {
	    str = str + attributes.get( i ) + "\n";
	}
	return str;
    }

    public void fromString( BufferedReader br )
    {
	int i;
	try {
	    setArrayIndex( Integer.parseInt( br.readLine() ) );
	    for (i=0; i<attributes.size(); i++) {
		setAttribute( i, br.readLine() );
	    }
	} catch (IOException ioe) {
	    System.out.println("Error reading object: " + ioe.toString() );
	}
    }

} // NSObject definition














