import java.lang.*;
import java.util.*;
import NSObject;
import NSArray;

public class NSWorld extends Object 
{
    ArrayList objects;
    ArrayList arrays;
    double endTime;
    Iterator objIter;

    public NSWorld ( NSObject inEnvironment )
    {
	// For convenience, the environment is always at index 0, and cannot be deleted.
	objects = new ArrayList();
	addObject( inEnvironment );
	arrays = new ArrayList();
    }

    public NSObject getEnvironment()
    {
	return ((NSObject)objects.get(0));
    }

    public void addArray( String inArrayName, int inNumberOfElements )
    {
	arrays . add( new NSArray( inArrayName, inNumberOfElements ) );
    }
    
    public void removeArray( int inIndex )
    {
	if (inIndex>=0 && inIndex < arrays.size()) {
	    arrays.remove( inIndex );
	}
    }

    public void removeAllArrays()
    {
	while (arrays.size()>0)
	    arrays.remove(0);
    }

    public NSArray getArray( int inIndex )
    {
	if (inIndex>=0 && inIndex<arrays.size())
	    return ((NSArray)arrays.get(inIndex));
	else {
	    System.out.println("Error: array index out of bounds.");
	    return null;
	}
    }

    public int getArrayCount()
    {
	return arrays.size();
    }

    public boolean isValidName( String theName )
    {
	NSObject o;
	Iterator i = objects.iterator();
	int j;

	while (i.hasNext()) {
	    o = (NSObject) i.next();
	    if ( o . getName() . equals( theName ) )
		return false;
	}
	return true;
    }

    public boolean addObject( NSObject newObject )
    {
	return (objects . add( newObject ));
    }

    public int getObjectCount() 
    {
	return objects . size();
    }

    public NSObject getObject( String theName )
    {
	NSObject o;
	Iterator i = objects.iterator();

	while (i.hasNext()) {
	    o = (NSObject) i.next();
	    if ( o . getName() . equals( theName ) )
		return o;
	}
	return null;
    }

    public NSObject getObject( int index )
    {
	if (index>=0 && index<objects.size())
	    return (NSObject) objects.get( index );
	else
	    return null;
    }

    public double getEndTime() 
    {
	return endTime;
    }

    public void setEndTime(double  newEndTime) 
    {
	endTime = newEndTime;
    }
    
    public String toString()
    {
	NSObject o;
	int i;
        String s = "";
        s = getEnvironment().getName() + "\n";
	s = s + Double.toString(getEndTime())+"\n";
    	for(i=0;i<objects.size();i++) {
	    o = getObject(i);
	    if (o != null)
		s = s + o.toString();
	}
	return s;
    }

}// NSWorld




