import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import NSObject;

public class SObjectTableModel extends AbstractTableModel
{
    NSObject o;

    public SObjectTableModel( NSObject inObject )
    {
	o = inObject;
    }

    public void updateView( NSObject inNewObject )
    {
	o = inNewObject;
    }

    public int getRowCount()
    {
	if (o==null) 
	    return 0;
	else
	    return o . getAttributeCount();
    }

    public int getColumnCount()
    {
	if (o==null)
	    return 0;
	else
	    return 2;
    }

    public Object getValueAt( int row, int col )
    {
	if (o == null) 
	    return new String("");

	if (col == 0) {
	    return o . getSnippet().getAttribute(row).name;
	} else {
	    return o . getAttribute(row);
	}
    }

    public void setValueAt( Object value, int row, int column )
    {
	if (column==1 && o!=null)
	    o . setAttribute( row, value.toString() );
    }
   
    public String getColumnName( int columnIndex )
    {
	if (columnIndex==0)
	    return "Attribute";
	else
	    return "Value";
    }

    public boolean isCellEditable(int rowIndex, int columnIndex)
    {
	if (columnIndex==0)
	    return false;
	else
	    return true;
    }
}
