
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import NScript;
import TclLibraryManager;
import TclLibrary;
import TclSnippet;
import NSIconPane;

public class SToolBar extends JPanel implements ActionListener
{
    NScript frame;
    TclLibraryManager libManager;
    JTabbedPane tabPane;
    JLabel action;
    NSIconPane nip;

    public SToolBar( NScript inFrame, TclLibraryManager inLibManager )
    {
	super( new BorderLayout() );
	frame = inFrame;
	libManager = inLibManager;
	action = new JLabel("Selection tool:");
	JPanel panel = new JPanel( new BorderLayout());
	panel.add(action,BorderLayout.NORTH);
	JPanel panel2 = new JPanel( new BorderLayout() );
	JButton b = new JButton(new ImageIcon("figs/select.gif"));
	b . setPreferredSize(new Dimension(22,22));
	b . addActionListener( this );
	panel2.add( b, BorderLayout.NORTH );
	panel.add(panel2,BorderLayout.WEST);
	tabPane = new JTabbedPane( JTabbedPane.TOP );
	panel.add(tabPane,BorderLayout.CENTER);
	nip = new NSIconPane(0,"NO ICON");
	add( panel, BorderLayout.CENTER );
	setBorder( new EmptyBorder(5,5,5,5));
    }

    public void addLibraryPane( TclLibrary lib )
    {
	int i;

	JList c = new JList(new STBListModel(lib));
       	c . setCellRenderer(nip);
	JScrollPane sp = new JScrollPane( c );
	tabPane . addTab(lib.getTBName(),sp);
	action.setText("Select an object");
    }

    public TclSnippet getSelectedSnippet()
    {
	int libIndex, snippetIndex;

	libIndex = tabPane . getSelectedIndex();
	if (libIndex<0)
	    return null;

	snippetIndex = ((JList)(((JScrollPane) tabPane . getSelectedComponent()).getViewport().getView())).getSelectedIndex();

	if (snippetIndex<0)
	    return null;
	else
	    return libManager.getSnippet(libIndex,snippetIndex);
    }
    
    public void clearSelection()
    {
	((JList)(((JScrollPane) tabPane . getSelectedComponent()).getViewport().getView())).clearSelection();
    }

    public void actionPerformed( ActionEvent ae )
    {
	clearSelection();
    }

    class STBListModel extends AbstractListModel
    {
	TclLibrary lib;
	public STBListModel( TclLibrary inLib )
	{
	    lib = inLib;
	}

	public Object getElementAt( int index )
	{
	    return lib . getSnippet( index );// . getName();
	}

	public int getSize()
	{
	    return lib.getSnippetCount();
	}
    }
}













