import java.lang.*;

public class TclAttribute extends Object
{
    String name, defaultValue, options;
    public boolean hasDefault, hasOptions;
    // Constructor
    public TclAttribute( String s )
    {
	parseSelf(s);
    }

    // Access methods
    public String getName( String inName )
    {
	return name;
    }
    public String getDefault()
    {
	return defaultValue;
    }

    public String getOptions()
    {
	return options;
    }

    void parseSelf( String s )
    {
	int defaultIndex, optionsIndex;

	defaultValue = "";
	options = "";

	s = s.trim();
	defaultIndex = s.indexOf('=');
	optionsIndex = s.indexOf(':');
	if (defaultIndex>=0) {
	    hasDefault = true;
	} else {
	    hasDefault = false;
	}
	if (optionsIndex>=0) {
	    hasOptions = true;
	} else {
	    hasOptions = false;
	}
	
	// Ok, now read
	if (hasDefault) {
	    name = s.substring(0,defaultIndex);
	    if (hasOptions) { 
		defaultValue = s.substring(defaultIndex+1,optionsIndex);
		options = s.substring(optionsIndex+1);
	    } else {
		
		defaultValue = s.substring(defaultIndex+1);
	    }
	} else {
	    if (hasOptions) {
		name = s.substring(0,optionsIndex);
		options = s.substring(optionsIndex+1);
	    } else {
		name = s;
	    }
	}
    }
    public String toString()
    {
	return name + " = " + defaultValue + " : " + options;
    }
}




