import TclLibrary;
import TclSnippet;
import java.util.*;
import java.io.*;

public class TclLibraryManager extends Object
{
    ArrayList libraries;

    public TclLibraryManager()
    {
	libraries = new ArrayList();
    }

    public boolean snippetNameExists(String snippetName)
    {
	TclLibrary l;
	Iterator i;

	i = libraries.iterator();
	while (i.hasNext()) {
	    l = (TclLibrary) i.next();
	    if (l.nameExists(snippetName))
		return true;
	}
	return false;
    }

    public boolean libNameExists(String libName)
    {
	TclLibrary l;
	Iterator i;

	i = libraries.iterator();
	while (i.hasNext()) {
	    l = (TclLibrary) i.next();
	    if (libName.equals(l.getName()))
		return true;
	}
	return false;
    }

    public boolean addLibrary( String fileName )
    {
	File f;
	FileReader fr;
	BufferedReader br;
	TclLibrary tl;
	int i;
	boolean go;

	try {
	    f = new File(fileName);
	    fr = new FileReader(f);
	    br = new BufferedReader(fr);
	    tl = new TclLibrary( br );
	    go = true;
	    go = !libNameExists(tl.getName());
	    for (i=0;i<tl.getSnippetCount();i++) {
		if (snippetNameExists(tl.getSnippet(i).getName()))
		    go = false;
	    }
	    if (go) {
		libraries.add( tl );
		return true;
	    } else 
		return false;
	} catch (FileNotFoundException e) {
	    System.out.println("Library file not found:"+e.toString());
	    return false;
	}
    }

    public int getLibraryCount()
    {
	return libraries.size();
    }

    public TclLibrary getLibrary( int inIndex )
    {
	if (inIndex >=0 && inIndex<libraries.size())
	    return (TclLibrary)libraries.get(inIndex);
	else
	    return null;
    }

    public TclLibrary getLibrary( String inLibName )
    {
	Iterator i;
	TclLibrary l;

	i = libraries.iterator();
	while (i.hasNext()) {
	    l = (TclLibrary)i.next();
	    if (inLibName.equals(l.getName()))
		return l;
	}
	return null;
    }

    public TclSnippet getSnippet( int inLibIndex, int inSnippetIndex)
    {
	TclLibrary l;

	if (inLibIndex>=0 && inLibIndex<libraries.size()) {
	    l = (TclLibrary)libraries.get(inLibIndex);
	    if (inSnippetIndex>=0 && inSnippetIndex<l.getSnippetCount())
		return l.getSnippet(inSnippetIndex);
	    else
		return null;
	} else {
	    return null;
	}
    }

    public TclSnippet getSnippet( String sName )
    {
	Iterator i = libraries.iterator();
	TclLibrary l;
	TclSnippet s;

	while (i.hasNext()) {
	    l = (TclLibrary)i.next();
	    s = l.getSnippet(sName);
	    if (s!=null)
		return s;
	}
	return null;
    }
}



